#include "shoki.h"
#include "shoki_config.h"
#include "shoki_doctrine.h"

extern int fcount_pt[MAX_FILTERS], callback_pt[MAX_FILTERS], rn_pt[MAX_FILTERS];
extern int d_pt[MAX_FILTERS], t_pt[MAX_FILTERS], q_pt[MAX_FILTERS];
extern int h_pt[MAX_FILTERS], sev_pt[MAX_FILTERS];
extern char **filter_pt, **hex_pt, **call_args_pt, **type_pt, **id_pt;
extern regex_t **regex_pt;
int nfilters, rnfilters;
extern char *fname, *filter, *dev, *outfile, *currentfile, *shoki_type;
extern char *filterlist;
extern int count, default_snaplen;
extern struct dconfig *dconfig_list;

char email_rcpt[256];

extern
int
parse_config(char *line)
{
	rnfilters = 0;
	nfilters = 0;
	if(!((char **)filter_pt = (char **)calloc(1, sizeof(char *) * (MAX_FILTERS + 1))))
		error("calloc:  parse_config");
	if(!((char **)hex_pt = (char **)calloc(1, sizeof(char *) * (MAX_FILTERS + 1))))
		error("calloc:  parse_config");
	if(!((char **)regex_pt = (char **)calloc(1, sizeof(regex_t *) * (MAX_FILTERS + 1))))
		error("calloc:  parse_config");
	if(!((char **)call_args_pt = (char **)calloc(1, sizeof(char *) * (MAX_FILTERS + 1))))
		error("calloc:  parse_config");
	if(!((char **)id_pt = (char **)calloc(1, sizeof(char *) * (MAX_FILTERS + 1))))
		error("calloc:  parse_config");
	if(!((char **)type_pt = (char **)calloc(1, sizeof(char *) * (MAX_FILTERS + 1))))
		error("calloc:  parse_config");
	if(!(dconfig_list = (struct dconfig *)calloc(1, sizeof(struct dconfig))))
		error("calloc:  parse_config");
	(void)parse_filter_config(line);
	return(0);
}

#define WHITE "= \n\r"
#define TAB "\t"

void
parse_filter_config(const char *config)
{
	FILE *f = NULL;
	char line[1024];
	int i = 0, j = 0, lnum = 0, k, t[3], re_flags = 0;
	char *foo, *bar = NULL, *baz = NULL, *hex = NULL;

	f = fopen(config, "r");
	if(!f) error("Couldn't read filter rules from %s", config);
	while(fgets(line, sizeof(line), f))
	{
		lnum++;
		if((rnfilters >= MAX_FILTERS) || (j >= MAX_FILTERS))
			error("Too many filters.  Change MAX_FILTERS.");
		foo = line;
		if(foo == NULL || !*foo || *foo == '#') continue;
		foo = strtok(foo, TAB);
		if(foo == NULL || !*foo || *foo == '#')
			error("Bad filter in %s, line %d.", config, lnum);
		j = nfilters + 1;
		if(!(filter_pt[j] = calloc(1, MAX_FILTER_LEN)))
			error("calloc:  parse_filter_config");
		strncpy(filter_pt[j], foo, MAX_FILTER_LEN);
		if(*filter_pt[j] == '!')
		{
			bar = filter_pt[j];
			bar++;
			filter_pt[j] = read_file(bar);
		}
		/* You better not be nesting your filter rules */
		if(strncasecmp(filter_pt[j], "include", 7) == 0)
		{
			bar = filter_pt[j];
			if(!(baz = (char *)calloc(1, strlen(bar))))
				error("calloc:  parse_filter_config");
			memcpy(baz, &bar[8], (strlen(bar) - 8));
			if(isspace(baz[strlen(baz) - 1]))
				baz[strlen(baz) - 1] = '\0';
			(void)parse_filter_config(baz);
			free(baz);
			continue;
		}
		if(strncasecmp(filter_pt[j], "doctrine", 8) == 0)
		{
			bar = filter_pt[j];
			i = 8;
			while(isspace(bar[i]) && bar[i] != '\0')
				i++;
			if(!(baz = (char *)calloc(1, (strlen(bar) - i))))
				error("calloc:  parse_filter_config");
			memcpy(baz, &bar[i], (strlen(bar) - i - 1));
			i = strlen(baz);
			while(isspace(baz[i]) && (i > 0))
			{
				baz[i] = '\0';
				i--;
			}
			(void)parse_doctrine_config(baz);
			free(baz);
			continue;
		}
		foo = strtok(NULL, TAB);
		if(foo == NULL || !*foo || *foo == '#')
			error("Bad filter in %s, line %d after filter.",
			config, lnum);
		fcount_pt[j] = atoi(foo);
		foo = strtok(NULL, TAB);
		if(foo == NULL || !*foo || *foo == '#')
			error("Bad filter in %s, line %d after count.",
			config, lnum);
		k = 0;
		while((baz = rindex(foo, ':')))
		{
			*baz = '\0';
			baz++;
			t[k] = atoi(baz);
			k++;
			if(k > 4)
				error("Bad filter in %s, line %d in callback.", config, lnum);
		}
		k--;
		if(k > 0)
		{
			if(k == 1)
				error("Bad filter in %s, line %d in callback.", config, lnum);
			d_pt[j] = t[k];
			t_pt[j] = t[k - 1];
			if(k > 1) q_pt[j] = t[k - 2];
			if(k > 2) h_pt[j] = t[k - 3];
		}
		callback_pt[j] = get_callback(foo);
		foo = strtok(NULL, TAB);
		if(foo == NULL || !*foo || *foo == '#')
			error("Bad filter in %s, line %d after callback.",
			config, lnum);
		if(!(id_pt[j] = calloc(1, MAX_ID_LEN)))
			error("calloc:  parse_filter_config");
		strncpy(id_pt[j], foo, MAX_ID_LEN);
		foo = strtok(NULL, TAB);
		if(foo == NULL || !*foo || *foo == '#')
			error("Bad filter in %s, line %d (%s) after ID.",
			config, lnum, id_pt[j]);
		if(!(call_args_pt[j] = calloc(1, MAX_CALLARG_LEN)))
			error("calloc:  parse_filter_config");
		strncpy(call_args_pt[j], foo, MAX_CALLARG_LEN);
		foo = strtok(NULL, TAB);
		if(foo == NULL || !*foo || *foo == '#')
			error("Bad filter in %s, line %d (%s) after args.",
			config, lnum, id_pt[j]);
		if(!(hex_pt[j] = (char *)calloc(1, MAX_HEX_LEN)))
			error("calloc:  parse_filter_config");
		regex_pt[j] = (regex_t *)calloc(1, sizeof(regex_t));
		if(!(baz = (char *)calloc(1, MAX_HEX_LEN)))
			error("calloc:  parse_filter_config");
		if(!(hex = (char *)calloc(1, 4)))
			error("calloc:  parse_filter_config");
		for(i=0, k=0; i <= strlen(foo); i++, k++)
		{
			if(strncasecmp(&foo[i], "0x", 2) == 0)
			{
				i += 2;
				while(isxdigit(foo[i]))
				{
					memcpy(hex, &foo[i], 2);
					hex[2] = '\0';
					baz[k] = strtol(hex, '\0', 16);
					i += 2;
					k++;
				}
				i--;
				k--;
			}
			else
				memcpy(&baz[k], &foo[i], 1);
		}
		if(strncasecmp(foo, "NULL", 4) == 0)
		{
		}
		else
		{
			strncpy(hex_pt[j], baz, MAX_HEX_LEN);
			re_flags = REG_EXTENDED | REG_NOSUB;
		}
		if(regcomp(regex_pt[j], hex_pt[j], (re_flags)) != 0)
			error("Problem compiling (%s) into regex in rule %d (%s)\n",
			hex_pt[j], j, id_pt[j]);
		free(baz);
		free(hex);
		foo = strtok(NULL, TAB);
		if(foo == NULL || !*foo || *foo == '#')
			error("Bad filter in %s, line %d (%s) after search.",
			config, lnum, id_pt[j]);
		if(!(type_pt[j] = calloc(1, MAX_TYPE_LEN)))
			error("calloc:  parse_filter_config");
		strncpy(type_pt[j], foo, MAX_TYPE_LEN);
		type_pt[j] = strtok(type_pt[j], WHITE);
		/* The severity level is optional */
		if(foo != NULL && *foo && *foo != '#')
		{
			sev_pt[j] = atoi(foo);
		}
		if(!( !(strcmp(type_pt[j], shoki_type)) ||
			(!(strcmp(type_pt[j], SHOKI_ALL)) &&
			(strcmp(shoki_type, SHOKI_IGNORE)))))
		{
			free(filter_pt[j]);
			fcount_pt[j] = 0;
			callback_pt[j] = 0;
			rn_pt[j] = 0;
			free(call_args_pt[j]);
			free(hex_pt[j]);
			free(type_pt[j]);
		}
		else
		{
			rn_pt[j] = rnfilters;
			nfilters++;
			rnfilters++;
		}
	}
}
