/*
Eventually:  some combantorics widgetry.  Now:  not a damn thing.
*/
#include "shoki_includes.h"
#include "shoki.h"
#include "shoki_init.h"
#include "shoki_doctrine.h"
#include "shoki_config.h"
#include "shoki_callback.h"
#include "shoki_map.h"

u_char *pcap_userdata = 0;
char *dumpfile = NULL, *real_outfile = NULL;
int callbacks = 1, fragre = 0, linux_kludge = 0, timeval_kludge = 0;
int rewrite = 0, silent = 0;
int firstsec, lastsec, malsize;
struct bpf_program base_fcode;
FILE *logfile = NULL;

pcap_handler out = pcap_print_pt;

extern int nfilters;

struct ether_edge eth_hash[ETH_HASH_SIZE][ETH_HASH_SIZE];

int main(int argc, char **argv)
{
	register int op;
	register char *cfile = NULL;
	register char *config = NULL;
	struct sigaction *cleansig;
	int Pflag = 0;

	shoki_type = strdup(SHOKI_TYPE);
	shoki_log_name = strdup(SHOKI_LOG_NAME);

	while((op = getopt(argc, argv, "Bc:C:E:fF:kKL:Pr:s:S:t:w:")) != EOF)
		switch(op)
		{
			case 'B':
				callbacks = 0;
				break;
			case 'c':
				count = atoi(optarg);
				break;
			case 'C':
				cfile = optarg;
				break;
			case 'E':
				stop = atoi(optarg);
				lastsec = stop;
				break;
			case 'f':
				fragre = 1;
				break;
			case 'F':
				filterlist = optarg;
				break;
			case 'k':
				linux_kludge = 1;
				break;
			case 'K':
				timeval_kludge = 1;
				break;
			case 'L':
				currentfile = optarg;
				break;
			case 'P':
				Pflag++;
				break;
			case 'r':
				dumpfile = optarg;
				break;
			case 's':
				default_snaplen = atoi(optarg);
				break;
			case 'S':
				start = atoi(optarg);
				firstsec = start;
				break;
			case 't':
				shoki_type = optarg;
				break;
			case 'w':
				real_outfile = optarg;
				rewrite = 1;
				break;
		}

	base_filter = get_filter(&argv[optind]);

	cleansig = malloc(sizeof(struct sigaction));

	cleansig->sa_handler = (void *)cleanup;
	cleansig->sa_flags = SA_RESTART & SA_NOCLDSTOP;

	(void)sigaction(SIGTERM, cleansig, NULL);
	(void)sigaction(SIGINT, cleansig, NULL);

	(void)hash_init();
	((cfile == NULL) ? (parse_shoki_config(PARSER_CONFIG)) : 
		(parse_shoki_config(cfile)));
	if((pf_outformat[0] == 0) || (pf_outdelim[0] == NULL))
		(void)default_formats(pf_outformat_d, pf_outdelim_d, pf_type_d);
	if((fname != NULL) && (base_filter == NULL))
		base_filter = read_file(fname);
	if(filterlist == NULL) error("Specify a filterlist, dammit.");
	config = read_file(filterlist);
	if(dumpfile == NULL)
		error("Specify a dump file, dammit.");
	if(filterlist != NULL) (void)parse_config(filterlist);
	if(default_snaplen == -1) (default_snaplen = DEFAULT_SNAPLEN);
	pd = fake_pcap(pd, 0);
	if(Pflag != 0) currentfile = NULL;
	/* Bad developer.  Bad.  No biscuit. */
	if(currentfile != NULL)
	{
		if(*currentfile == '-')
			logfile = stdout;
		else
			logfile = fopen(currentfile, "a");
	}
       	if(logfile == NULL) (void)log_msg(NULL, NULL, NULL, "map starting");
	(void)read_zdumps(dumpfile, out);
	(void)print_nodes();
	if(logfile) (void)fclose(logfile);
	cleanup(0);
	exit(0);
}

int
cleanup(int signo)
{
	if(pd != NULL && pcap_file(pd) == NULL)
	{
		(void)fflush(stdout);
		putc('\n', stderr);
	}
       	if(logfile == NULL) (void)log_msg(NULL, NULL, NULL, "map shutting down");
	exit(0);
}

void
pcap_print_pt(u_char *user, const struct pcap_pkthdr *h, const u_char *sp)
{
	const struct timeval *tvp;
	int i, foo = 0;

	(const struct timeval *)tvp = &h->ts;
	if(stop && (tvp->tv_sec > stop)) return;
	if(start && (tvp->tv_sec < start)) return;
	if(!firstsec || (firstsec > tvp->tv_sec)) firstsec = tvp->tv_sec;
	if(lastsec < tvp->tv_sec) lastsec = tvp->tv_sec;

	for(i = 1, foo = 0; (i <= nfilters) && (foo == 0); i++)
	{
		if(bpf_filter(fcode_pt[i]->bf_insns, (u_char *)sp, h->len, h->caplen))
		{
			foo++;
			munge_packet(h, sp);
		}
	}
}

void
munge_packet(const struct pcap_pkthdr *h, const u_char *sp)
{
	struct ether_header *ep;
	struct ip *ip;
	struct tcphdr *tp;
	struct udphdr *up;
	struct icmphdr *dp;
	int hlen, i;
	u_int64_t se, de;

	ep = (struct ether_header *)sp;
	memcpy(&se, &ep->ether_shost, (sizeof(u_int8_t) * (ETH_ALEN)));
	memcpy(&de, &ep->ether_dhost, (sizeof(u_int8_t) * (ETH_ALEN)));
	memcpy(&eth_hash[se % ETH_HASH_SIZE][de % ETH_HASH_SIZE].src, &ep->ether_shost, (sizeof(u_int8_t) * (ETH_ALEN)));
	memcpy(&eth_hash[se % ETH_HASH_SIZE][de % ETH_HASH_SIZE].dst, &ep->ether_dhost, (sizeof(u_int8_t) * (ETH_ALEN)));
	ip = (struct ip *)(sp + sizeof(struct ether_header));
	hlen = (ip->ip_hl * 4) - 20;
	switch(ip->ip_p)
	{
		case IPPROTO_TCP:
			tp = (struct tcphdr *)(sp + sizeof(struct ether_header) + sizeof(struct ip) + hlen);
			break;
		case IPPROTO_UDP:
			up = (struct udphdr *)(sp + sizeof(struct ether_header) + sizeof(struct ip) + hlen);
			break;
		case IPPROTO_ICMP:
			dp = (struct icmphdr *)(sp + sizeof(struct ether_header) + sizeof(struct ip) + hlen);
			break;
		default:
			break;
	}
}


void
print_nodes()
{
	int i, j, k, l, m;

	for(i = 0; i < ETH_HASH_SIZE; i++)
	{
		for(j = 0; j < ETH_HASH_SIZE; j++)
		{
			for(k = 1, l = 0, m = 0; k <= ETH_ALEN; k++)
			{
				l += eth_hash[i][j].src[k];
				m += eth_hash[i][j].dst[k];
			}
			if((l == 0) || (m == 0)) continue;
			printf("%s > %s\n", etheraddr_string(eth_hash[i][j].src), etheraddr_string(eth_hash[i][j].dst));
		}
	}
}


/* from the tcpdump source */
char *
etheraddr_string(const u_char *ep)
{
	u_int i, j;
	char *cp, *foo;
	char buf[sizeof("00:00:00:00:00:00")];

	cp = buf;
	if((j = *ep >> 4) != 0)
		*cp++ = hex[j];
	*cp++ = hex[*ep++ & 0xf];
	for(i = 5; (int)--i >= 0;)
	{
		*cp++ = ':';
		if((j = *ep >> 4) != 0)
			*cp++ = hex[j];
		*cp++ = hex[*ep++ & 0xf];
	}
	*cp = '\0';
	foo = (char *)malloc(sizeof("00:00:00:00:00:00"));
	(void)strcpy(foo, buf);
	return(foo);
}

void
hash_init()
{
	int i, j, k;

	for(i = 0; i < ETH_HASH_SIZE; i++)
	{
		for(j = 0; j < ETH_HASH_SIZE; j++)
		{
			for(k = 1; k <= ETH_ALEN; k++)
			{
				eth_hash[i][j].src[k] = 0;
				eth_hash[i][j].dst[k] = 0;
			}
		}
	}
}

