#!/usr/bin/perl

use Time::Local;
require("getopts.pl");
&read_config("/etc/shoki.conf");
require("$INSTALL_PREFIX/$ETCDIR/collector.conf");
&Getopts("t:");

$resolution = (60 * 60);		# one hour
$logdir = "$INSTALL_PREFIX/central/log";
$service = "$INSTALL_PREFIX/$BINDIR/service";
$service_flags = "-L - -p -I $resolution -t";


&main();
exit(0);


sub main
{
	my($time, $start, $end);

	$time = &parse_options();
	($start, $end) = &get_endpoints($time);
	foreach $foo (@sensors)
	{
		@logs = &get_logs($foo, $start, $end);
		&get_numbers($start, $end, @logs);
		&report($start, $end);
		exit(0);
	}
}


sub get_endpoints
{
	my($time) = @_;
	my(@foo, @bar, $start, $end);

	@foo = localtime($time);
	@bar = @foo;
	$foo[0] = 0;
	$foo[1] = 0;
	$foo[2] = 0;
	$bar[0] = 59;
	$bar[1] = 59;
	$bar[2] = 23;
	$start = timelocal(@foo);
	$end = timelocal(@bar);
	return($start, $end);
}

sub read_config
{
	my($fname) = @_;

	open(FILE, "<$fname") || (die "Couldn't read $fname");
	while(<FILE>)
	{
		/^(\w+)(\s*)=(\s*)(.+)$/ || next;
		${$1} = $4;
	}
	close(FILE);
}

sub parse_options
{
	$opt_t && return($opt_t);
	return(time);
}

sub get_logs
{
	my($sensor, $start, $end) = @_;
	my($fname, @logs);

	(-d "$logdir/$foo") || return;
	opendir(DIR, "$logdir/$foo") || return;
	@logs = ();
	while($fname = readdir(DIR))
	{
		($fname =~ /^$foo-sensor_dump\.(\d+)-(\d+)\.gz$/) || next;
		($end >= $1) || next;
		($start <= $2) || next;
		push(@logs, "$logdir/$foo/$fname");
	}
	return(@logs);
}

sub get_numbers
{
	my($start, $end, @logs) = @_;
	my($loglist, $inc);

	$loglist = join(' ', @logs);
	$inc = 0;
	%ports = ();
	%daily = ();
	open(PIPE, "$service $service_flags -S $start -E $end -r \"$loglist\"|")
		|| return;
	while(<PIPE>)
	{
		chomp;
		s/^(\s+)//g;
		@foo = split('\s+', $_);
		$daily{$foo[0]}{$inc} += $foo[1];
		print "foo:  ($foo[0])  ($foo[1])\n";
		$ports{$foo[0]}++;
		($foo[0] eq 'total') && ($inc += $resolution);
	}
	close(PIPE);
}

sub report
{
	my($start, $end) = @_;
	my($foo, $bar, $inc);

	$inc = 0;
	while($inc <= (($end - $start) + 1))
	{
		foreach $foo (sort(keys %ports))
		{
			#$daily{$foo}{$inc} || next;
			print "$inc:  ($foo)\t($daily{$foo}{$inc})\n";
			$inc += $resolution;
		}
	}
}
