#!/usr/bin/perl

$cutoff = time - (24 * 60 * 60);	# the last 24 hours

&read_config("/etc/shoki.conf");
require("$INSTALL_PREFIX/$ETCDIR/collector.conf");
$shoki_conf = "$INSTALL_PREFIX/$ETCDIR/shoki.conf";
&read_config($shoki_conf);

&main();
exit(0);

sub main
{
	&read_dirs();
	&do_service();
}

sub read_config
{
	my($fname) = @_;
	open(FILE, "<$fname") ||
	(die "Couldn't read $fname");
	while(<FILE>)
	{
		/^(\w+)(\s*)=(\s*)(.+)$/ || next;
		${$1} = $4;
	}
	close(FILE);
}


sub read_dirs
{
	my($foo, $fname, $fname_w);
	foreach $foo (sort(@sensors))
	{
		(-d "$logdir/$foo") || next;
		$logs{$foo} = "";
		opendir(DIR, "$logdir/$foo") || next;
		while($fname = readdir(DIR))
		{
			($fname =~ /\.gz$/) || next;
			($fname =~ /(\d+)-(\d+)/ ) || next;
			($1 < $cutoff) && next;
			$fname_w = "$logdir/$foo/$fname";
			$logs{$foo} .= "$fname_w ";
		}
		closedir(DIR);
	}
}

sub do_service
{
	foreach $foo (sort(@sensors))
	{
		print "$foo:\n";
		open(PIPE, "$INSTALL_PREFIX/$BINDIR/service -r \"$logs{$foo}\" -h -t|") || next;
		while(<PIPE>)
		{
			print;
		}
		close(PIPE);
		print "\n\n\n";
	}
}
